/********************************** (C) COPYRIGHT *******************************
 * File Name          : Main.c
 * Author             : WCH
 * Version            : V1.0
 * Date               : 2020/08/06
 * Description        : 1շʾ
 *********************************************************************************
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * Attention: This software (modified or not) and binary are used for 
 * microcontroller manufactured by Nanjing Qinheng Microelectronics.
 *******************************************************************************/

#include "CH59x_common.h"

#include "port_intr.h"
#include "gat/gat_gpio.h"
#include "device/ch32sub.h"



void ch59x_xtal_conf()
{
    HSECFG_Current(HSE_RCur_125);
    HSECFG_Capacitance(HSECap_14p);
}

uint8_t TxBuff[] = "This is a tx exam\r\n";
uint8_t RxBuff[100];
uint8_t trigB;

/*********************************************************************
 * @fn      main
 *
 * @brief   
 *
 * @return  none
 */
int main()
{
    //uint8_t len;

    // configure clock
    ch59x_xtal_conf();
    SetSysClock(CLK_SOURCE_PLL_32MHz);

    // enable DC-DC converter
    PWR_DCDCCfg(ENABLE);

    // configure port-based interrupts
    port_intr_init();

    // configure aux MCU initial settings, attention interrupt
    ch32sub_init();

    // configure GAT aux GPIOs, get gat ID
    gat_gpio_init();
    // configure GAT i2c slave


/*
    // ô1IOģʽô
    GPIOA_SetBits(GPIO_Pin_9);
    GPIOA_ModeCfg(GPIO_Pin_8, GPIO_ModeIN_PU);      // RXD-
    GPIOA_ModeCfg(GPIO_Pin_9, GPIO_ModeOut_PP_5mA); // TXD-עIOߵƽ
    UART1_DefInit();

#if 1 // Դڷַ
    UART1_SendString(TxBuff, sizeof(TxBuff));

#endif

#if 1 // ѯʽݺͳȥ
    while(1)
    {
        len = UART1_RecvString(RxBuff);
        if(len)
        {
            UART1_SendString(RxBuff, len);
        }
    }

#endif

#if 0 // жϷʽݺͳȥ
    UART1_ByteTrigCfg(UART_7BYTE_TRIG);
    trigB = 7;
    UART1_INTCfg(ENABLE, RB_IER_RECV_RDY | RB_IER_LINE_STAT);
    PFIC_EnableIRQ(UART1_IRQn);
#endif
*/

    while(1) {
        // only care about aux MCU when all other processing is done
        ch32sub_process();
    }
}

/*********************************************************************
 * @fn      UART1_IRQHandler
 *
 * @brief   UART1жϺ
 *
 * @return  none
 */
__INTERRUPT
__HIGH_CODE
void UART1_IRQHandler(void)
{
    /*
    volatile uint8_t i;

    switch(UART1_GetITFlag())
    {
        case UART_II_LINE_STAT: // ·״̬
        {
            UART1_GetLinSTA();
            break;
        }

        case UART_II_RECV_RDY: // ݴﵽô
            for(i = 0; i != trigB; i++)
            {
                RxBuff[i] = UART1_RecvByte();
                UART1_SendByte(RxBuff[i]);
            }
            break;

        case UART_II_RECV_TOUT: // ճʱʱһ֡ݽ
            i = UART1_RecvString(RxBuff);
            UART1_SendString(RxBuff, i);
            break;

        case UART_II_THR_EMPTY: // ͻգɼ
            break;

        case UART_II_MODEM_CHG: // ִֻ֧0
            break;

        default:
            break;
    }
    */
}
