/*
 * port_intr.c
 *
 *  Created on: Oct 11, 2024
 *      Author: true
 */

#include "CH59x_common.h"
#include "port_intr.h"

#include <stdint.h>



static void (*cb[2][24])(void) = {0};



void port_intr_cb_register(uint8_t port, uint8_t idx, void (*fn)(void))
{
    if (idx >= 24) return;
    if (port > 2) return;

    cb[port][idx] = fn;
}

void port_intr_init()
{

}



/* interrupt handlers */
__INTERRUPT
__HIGH_CODE
void GPIOA_IRQHandler(void)
{

}

__INTERRUPT
__HIGH_CODE
void GPIOB_IRQHandler(void)
{
    uint8_t i;
    uint16_t flag = R16_PB_INT_IF;

    // high priority actions
    // none.

    // general purpose fallback
    for (i = 0; i < 24; i++) {
        if (flag & (1 << i)) {
            if (cb[PORT_INTR_GPIOB][i]) {
                cb[PORT_INTR_GPIOB][i]();
            }
        }
    }

    // clear flags
    R16_PB_INT_IF = flag;
}
